(function() {
    printLog("inner_ad_manager begin");
	
	function _init() {
	    printLog("inner_ad_manager _init");
		
		// 初始化参数
		related_ad = document.getElementById("related_ad");
		
			
	    // 注册相关广告渲染接口
	    window.InnerBridge.registerHandler("jsFunctionRenderAd", window.InnerAdManager.jsFunctionRenderAd);
	
	    // 注册相关广告渲染接口
	    window.InnerBridge.registerHandler("jsFunctionSyncAdStatus", window.InnerAdManager.jsFunctionSyncAdStatus);
    }

	function _jsFunctionRenderAd(data, responseCallback) {
		var relatedAd = JSON.parse(data);
		printLog("inner_ad_manager _jsFunctionRenderAd");
		
		if (relatedAd && relatedAd.length > 0) {
		    related_ad.innerHTML = "";
			var tempHtml = "";
		    for(var i=0; i < relatedAd.length; i++){
				printLog("inner_ad_manager _jsFunctionRenderAd tindex:" + relatedAd[i].tindex);
				for (var j = 0; j < relatedAd[i].singles.length; j++) {
					printLog("inner_ad_manager _jsFunctionRenderAd sindex:" + relatedAd[i].singles[j].sindex);
					printLog("inner_ad_manager _jsFunctionRenderAd item.patchedAppName:" + relatedAd[i].singles[j].item.patchedAppName);
					printLog("inner_ad_manager _jsFunctionRenderAd item.imageUrl:" + relatedAd[i].singles[j].item.imageUrl);
					printLog("inner_ad_manager _jsFunctionRenderAd item.largeImageUrl:" + relatedAd[i].singles[j].item.largeImageUrl);
					
					// icon图
					tempHtml += "<div class='ad_inner'>";
					tempHtml += "<div class='ad_inner_head'>";
				    tempHtml += "<div class='ad_inner_icon'><img class='footer_ads_icon' src='" + relatedAd[i].singles[j].item.imageUrl + "' width='48px' height='48px'/>" + "</div>";
					
					// app名称
					var width = document.body.clientWidth;
					if (width >= 360) {
						tempHtml += "<div class='ad_inner_title_big'>";
					} else {
						tempHtml += "<div class='ad_inner_title_small'>";
					}
					tempHtml += "<div class='ad_inner_name' id='footer_ads_title'>" + relatedAd[i].singles[j].item.patchedAppName + "</div><div class='ad_inner_people'>" + relatedAd[i].singles[j].item.patchedAdDesc + "</div></div>";
					
					// 按钮
					var button_id = "button_tindex_" + relatedAd[i].tindex + "sindex_" + relatedAd[i].singles[j].sindex;
					if (relatedAd[i].singles[j].item.buttonText && relatedAd[i].singles[j].item.buttonText != null) {
					    tempHtml += "<div class='ad_inner_button' id='" + button_id + "'" + " tindex='" + relatedAd[i].tindex + "' sindex='" + relatedAd[i].singles[j].sindex + "'" + " onClick='InnerAdManager.clickRelateAd.call(this)'" + ">" + relatedAd[i].singles[j].item.buttonText + "</div>" + "";
					} else {
					    tempHtml += "<div class='ad_inner_button' id='" + button_id + "'" + " tindex='" + relatedAd[i].tindex + "' sindex='" + relatedAd[i].singles[j].sindex + "'" +  " onClick='InnerAdManager.clickRelateAd.call(this)'" + ">下载</div>" + "";
					}
					
					// 大图
					tempHtml += "<div style='clear:both;height:0px;'></div></div>";
					tempHtml += "<div class='ad_inner_body'><div class='ad_inner_body_float'><img src='" + relatedAd[i].singles[j].item.largeImageUrl + "'/>";
					tempHtml += "<div class='ad_message'>" + relatedAd[i].singles[j].item.patchedShortDesc + "</div>";
					
					tempHtml += "</div><div style='clear:both;height:0px;'></div></div>";
					tempHtml += "</div>";
					
					related_ad_list.push(button_id);
				}
			}
			related_ad.innerHTML = tempHtml;
		}

		if (responseCallback) {
			responseCallback("inner_ad_manager _jsFunctionRenderAd ret");
		}
	}
	
	function _jsFunctionSyncAdStatus(data, responseCallback) {
		var adStatus = JSON.parse(data);
		printLog("inner_ad_manager _jsFunctionSyncAdStatus buttonText:" + adStatus.buttonText);
		printLog("inner_ad_manager _jsFunctionSyncAdStatus tIndex:" + adStatus.tindex);
		printLog("inner_ad_manager _jsFunctionSyncAdStatus sindex:" + adStatus.sindex);
		if (adStatus) {
		    var button_id = "button_tindex_" + adStatus.tindex + "sindex_" + adStatus.sindex;
		    var relateButton = document.getElementById(button_id);
			if (relateButton) {
			    //relateButton.innerHTML = "<div id='" + button_id + "'" + " tindex='" + adStatus.tindex + "' sindex='" + adStatus.sindex + "'" + " onClick='InnerAdManager.clickRelateAd.call(this)'" + ">" + adStatus.buttonText + "</div>";
				
				relateButton.innerHTML = adStatus.buttonText;
				if (adStatus.status == '9' || adStatus.status == '10' || adStatus.status == '11' || adStatus.status == '12') {
					relateButton.className = "ad_inner_button_orange";
				}
			}
		}

		if (responseCallback) {
			responseCallback("inner_ad_manager _jsFunctionSyncAdStatus ret");
		}
	}
	
	function _clickRelateAd() {
		printLog("inner_ad_manager _clickRelateAd id:" + this.getAttribute("id"));
	    printLog("inner_ad_manager _clickRelateAd tindex:" + this.getAttribute("tindex"));
		printLog("inner_ad_manager _clickRelateAd sindex:" + this.getAttribute("sindex"));
		window.InnerBridge.callHandler("funcAdClick", "{tindex:" + this.getAttribute("tindex") + ",sindex:" + this.getAttribute("sindex") + "}", false);
	}
	
	function _poolLoop() {
		printLog("inner_ad_manager _poolLoop size:" + related_ad_list.length);
		var storedAdSize = related_ad_list.length;
		if (storedAdSize > 0) {
			for (var i = 0; i < storedAdSize; i++) {
				var id = related_ad_list[i];
				if (id != null) {
					var ad = document.getElementById(id);
					if (ad && inView(ad)) {
					    var tindex = ad.getAttribute("tindex")
						var sindex = ad.getAttribute("sindex")
						window.InnerBridge.callHandler("funcAdPv", "{tindex:" + tindex + ",sindex:" + sindex + "}", false);
						related_ad_list.splice(i, 1);
						storedAdSize = related_ad_list.length;
						i--;
					}
				}
			}
		}
	}
	
	var InnerAdManager = window.InnerAdManager = {
	    init: _init,
		jsFunctionRenderAd: _jsFunctionRenderAd,
		jsFunctionSyncAdStatus:_jsFunctionSyncAdStatus,
		clickRelateAd: _clickRelateAd,
		poolLoop:_poolLoop
    };
	
	var related_ad;
	var related_ad_list = [];
		
	var doc = document;
    var readyEvent = doc.createEvent('Events');
    readyEvent.initEvent('InnerAdManagerReady');
    doc.dispatchEvent(readyEvent);
	
	printLog("inner_ad_manager end");
})();